package com.pixelized.server.lwa.server.rest.campaign

import com.pixelized.server.lwa.server.Engine
import com.pixelized.server.lwa.utils.extentions.characterSheetId
import com.pixelized.server.lwa.utils.extentions.exception
import com.pixelized.shared.lwa.protocol.rest.APIResponse
import com.pixelized.shared.lwa.protocol.websocket.CampaignEvent
import io.ktor.server.response.respond
import io.ktor.server.routing.RoutingContext

fun Engine.putCampaignNpc(): suspend RoutingContext.() -> Unit {
    return {
        try {
            // get the query parameter
            val characterSheetId = call.queryParameters.characterSheetId
            // add the character to the npcs.
            campaignService.addNpc(
                characterSheetId = characterSheetId,
            )
            // API & WebSocket responses.
            call.respond(
                message = APIResponse.success(),
            )
            webSocket.emit(
                value = CampaignEvent.NpcAdded(
                    timestamp = System.currentTimeMillis(),
                    characterSheetId = characterSheetId,
                )
            )
        } catch (exception: Exception) {
            call.exception(
                exception = exception
            )
        }
    }
}